// Copyright 1997-2004 Omni Development, Inc.  All rights reserved.
//
// This software may only be used and reproduced according to the
// terms in the file OmniSourceLicense.html, which should be
// distributed with this project and can also be found at
// <http://www.omnigroup.com/developer/sourcecode/sourcelicense/>.
//
// $Header: /Source/CVS/OmniGroup/Frameworks/OmniFoundation/Scheduling.subproj/OFQueueProcessor.h,v 1.14.2.1 2004/05/17 17:08:21 kc Exp $

#import <OmniFoundation/OFObject.h>

@class NSLock;
@class OFInvocation, OFMessageQueue;

#import <Foundation/NSDate.h>
#import <OmniFoundation/OFMessageQueuePriorityProtocol.h> // For OFMessageQueueSchedulingInfo

@interface OFQueueProcessor : OFObject
{
    OFMessageQueue *messageQueue;

    NSLock *currentInvocationLock;
    OFInvocation *currentInvocation;
    OFMessageQueueSchedulingInfo schedulingInfo;
}

- initForQueue:(OFMessageQueue *)aQueue;

- (void)processQueueUntilEmpty;
- (void)processQueueForever;
- (void)startProcessingQueueInNewThread;

- (void)processQueueUntilEmpty:(BOOL)onlyUntilEmpty forTime:(NSTimeInterval)maximumTime;

- (OFMessageQueueSchedulingInfo)schedulingInfo;

@end

#import <OmniFoundation/FrameworkDefines.h>

OmniFoundation_EXTERN BOOL OFQueueProcessorDebug;
